#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>
#include <fakemeta>
#include <engine>

#define PLUGIN "Press To Pickup"
#define VERSION "1.0"
#define AUTHOR "DarkGL"

enum TypeWeapon{
	NONE,
	PRIMARY,
	SECONDARY,
	THIRD,
	FOUR,
	FIVE
}

new hudSyncObject;

new touchEnt[ 33 ];

new const modelToNameArray[ 33 ][ 2 ] = {
	{ 0, _:NONE },
	{ 1, _:SECONDARY},
	{ 2, _:NONE },
	{ 3, _:PRIMARY},
	{ 4, _:FOUR},
	{ 5, _:PRIMARY},
	{ 6, _:FIVE},
	{ 7, _:PRIMARY },
	{ 8, _:PRIMARY},
	{ 9, _:FOUR },
	{ 10,_:SECONDARY },
	{ 11,_:SECONDARY },
	{ 12,_:PRIMARY },
	{ 13,_:PRIMARY },
	{ 14,_:PRIMARY },
	{ 15,_:PRIMARY },
	{ 16,_:SECONDARY },
	{ 17,_:SECONDARY },
	{ 18,_:PRIMARY },
	{ 19,_:PRIMARY },
	{ 20,_:PRIMARY },
	{ 21,_:PRIMARY },
	{ 22,_:PRIMARY },
	{ 23,_:PRIMARY },
	{ 24,_:PRIMARY },
	{ 25,_:FOUR },
	{ 26,_:SECONDARY },
	{ 27,_:PRIMARY },
	{ 28,_:PRIMARY },
	{ 29,_:THIRD },
	{ 30,_:PRIMARY },
	{ 31,_:NONE },
	{ 32,_:NONE }
	
}

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	hudSyncObject	= CreateHudSyncObj();
	
	RegisterHam( Ham_Touch , "weaponbox" , "fwTouch" , 1 );
	
	register_impulse( 100 , "hookFlashlight" );
	
	server_cmd( "mp_flashlight 1" );
}

public fwTouch( pToucher , pTouched ){
	if( !pev_valid( pToucher ) || !pev_valid( pTouched ) ){
		return HAM_IGNORED;
	}
	
	if( !is_user_alive( pTouched ) ){
		return HAM_IGNORED;
	}
	
	touchEnt[ pTouched ] = pToucher;
	
	return HAM_IGNORED;
}

public hookFlashlight( id ){
	if( !touchEnt[ id ] ){
		return PLUGIN_CONTINUE;
	}
	
	new 	szWeaponName[ 64 ];
		
	new 	iWeapons[32],
		iNum;
		
	new	dropWeaponID = 0;
	
	get_user_weapons( id, iWeapons, iNum );
	
	new	entMainWeapon = findByOwner( touchEnt[ id ] );
	
	if( !pev_valid( entMainWeapon ) ){
		return PLUGIN_HANDLED;
	}
	
	new szClassName[ 64 ];
	
	pev( entMainWeapon , pev_classname , szClassName , charsmax( szClassName ) );
	
	new weaponID = get_weaponid( szClassName );
	
	new weaponIDArray = findWeaponById( weaponID );
	
	for( new iWeapon = 0; iWeapon < iNum; iWeapon++ ){
		new indexArray = findWeaponById( iWeapons[ iWeapon ] );
		
		if( !indexArray ){
			continue;
		}
		
		if( modelToNameArray[ indexArray ][ 1 ] == modelToNameArray[ weaponIDArray ][ 1 ] ){
			dropWeaponID = indexArray;
			
			break;
		}
	}
	
	if( !dropWeaponID ){
		return PLUGIN_HANDLED;
	}
	
	get_weaponname(  modelToNameArray[ dropWeaponID ][ 0 ] , szWeaponName , charsmax( szWeaponName ) );
	
	engclient_cmd( id , "drop" , szWeaponName );
	
	return PLUGIN_HANDLED;
}

public client_PreThink( id ){
	
	if( touchEnt[ id ] == 0 ){		
		return PLUGIN_CONTINUE;
	}
	
	if( !pev_valid( touchEnt[ id ] ) ){
		touchEnt[ id ] = 0;
		
		return PLUGIN_CONTINUE;
	}
	
	new 	szWeaponName[ 64 ],
		szClassName[ 64 ],
		entMainWeapon = findByOwner( touchEnt[ id ] );
	
	pev( entMainWeapon , pev_classname , szClassName , charsmax( szClassName ) );
	
	new weaponID = get_weaponid( szClassName );
	
	new weaponIDArray = findWeaponById( weaponID );
	
	if( !weaponIDArray ){
		touchEnt[ id ] = 0;
	
		return PLUGIN_CONTINUE;
	}
		
	get_weaponname(  modelToNameArray[ weaponIDArray ][ 0 ] , szWeaponName , charsmax( szWeaponName ) );
	
	replace( szWeaponName , charsmax( szWeaponName ) , "weapon_" , "" );
	
	strtoupper( szWeaponName );
	
	set_hudmessage(0, 255, 0, -1.0, 0.80, 0, 0.1, 0.1)
	
	ShowSyncHudMsg( id , hudSyncObject , "Press F to pickup %s" , szWeaponName );
	
	touchEnt[ id ] = 0;
	
	return PLUGIN_CONTINUE;
}


findWeaponById( const weaponID ){
	for( new iModel = 0; iModel < 32 ; iModel++ ){
		if( modelToNameArray[ iModel ][ 0 ] == weaponID ){
			return iModel;
		}
	}
	
	return 0;
}

findByOwner( ownerID ){
	new maxEntities = get_global_int(GL_maxEntities);

	new 	iEnt,
		szClassName[ 64 ];
	
	for( iEnt = 0;iEnt < maxEntities;iEnt++ ){
		if( !is_valid_ent( iEnt ) ){
			continue;
		}
	
		entity_get_string( iEnt,EV_SZ_classname,szClassName, charsmax( szClassName ) );
	
		if( entity_get_edict( iEnt , EV_ENT_owner) == ownerID ){
			return iEnt;
		}
	}
	
	return 0;
}
